Last Comment Bug 281960 - [devmo] Mozilla CSS support chart
: [devmo] Mozilla CSS support chart
Status: RESOLVED FIXED
:
Product: Developer Documentation
Classification: Other
Component: General (show other bugs)
: unspecified
: All All
: -- normal (vote)
: ---
Assigned To: Deb Richardson [:dria] (plz NEEDINFO)
:
Mentors:
http://developer.mozilla.org/en/docs/...
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2005-02-11 10:54 PST by Anne (:annevk)
Modified: 2012-12-28 16:05 PST (History)
25 users (show)
See Also:
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
draft #1 (27.56 KB, text/html;charset=utf-8)
2005-02-11 10:55 PST, Anne (:annevk)
no flags Details
draft #2 (26.23 KB, text/html;charset=utf-8)
2005-02-13 06:25 PST, Anne (:annevk)
no flags Details
draft #3 (27.51 KB, text/html;charset=utf-8)
2005-02-14 13:01 PST, Anne (:annevk)
no flags Details
draft #4 (27.40 KB, text/html;charset=utf-8)
2005-02-17 07:41 PST, Anne (:annevk)
no flags Details
draft #5 (28.50 KB, text/html;charset=utf-8)
2005-02-20 08:54 PST, Anne (:annevk)
no flags Details

Description Anne (:annevk) 2005-02-11 10:54:22 PST
As discussed with fantasai. Attaching first draft.
Comment 1 Anne (:annevk) 2005-02-11 10:55:17 PST
Created attachment 174067 [details]
draft #1
Comment 2 Vidar Haarr (not reading bugmail) 2005-02-11 12:17:57 PST
I'm not sure, but it might be a good idea to read
<http://www.quirksmode.org/css/contents.html> and
<http://www.quirksmode.org/bugreports/archives/mozilla/index.html>, and perhaps
incorporate some of the comments there into this document.
Comment 3 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2005-02-11 12:18:20 PST
There are a huge number of mistakes here.  Off the top of my head, without
careful review:

This should be called a CSS2 support chart, since it doesn't mention any CSS3 stuff.

There were versions before 1.0.  You should at least indicate ≤1.0.

:active varies in quirks mode just like :hover

counter-increment and counter-reset are not supported

font-size-adjust is supported on some platforms

quotes was partly supported (only the first pair of values) before 1.8

some values for content are not supported

table-layout has been supported for a long time

visibility: collapse has been supported for a long time

white-space is only partially supported (it's too buggy on inlines to actually
call it supported)
Comment 4 Anne (:annevk) 2005-02-11 13:06:47 PST
I was planning to CC the CSS crew later, when my draft was a bit better, but I
guess this works as well.

To make the document more useful and easier to critize we should define support
for a property, selector and at-rule. Probably in this bug. (thanks bz)

I'm planning to add CSS 3 as well. Although I will not list all properties as
with CSS 2.1, just the ones that are supported. I guess it would make sense to
put those in a separate table. (And the CSS 3 selectors in a separate table as
well. Perhaps the CSS 2.1 selector table is not needed anymore then.)

I'm not sure about defining support. If we really did not support the property
or selector, it would go back to -moz- I guess like we have done before. So
every property or selector that does not have that is supported.

However, most of them have minor problems or problems are created thanks to CSS
2.1. Those should be listed in the notes field.

Also, I will maintain the document. I follow most (if not all) CSS related bugs
and I have commit access to the website to make changes when necessary.
Comment 5 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2005-02-11 13:33:55 PST
Also, you still haven't defined what "Yes" and "No" mean, which is why a bunch
of us think support charts are a bad idea.
Comment 6 Anne (:annevk) 2005-02-13 06:25:57 PST
Created attachment 174213 [details]
draft #2

This document makes things a bit clearer and includes suggestions from both
fantasai and dbaron.

Yes = release (starting from 1.0) since when Mozilla recognizes the property
and its values and does something with it. (Important bugs should be noted in
"Notes".)

No = not supported
Comment 7 Boris Zbarsky [:bz] 2005-02-13 22:19:00 PST
The note about :selected is flat wrong -- we do allow styling of all those
elements.  There are just some properties (a very very few) that have !important
rules overriding any styles the page sets.

I see no notes about the dynamic bugs with :first-child, :last-child,
:only-child, :empty.  The note on :empty isn't in English.

1.8 is not released yes, so I'm not sure why you're saying it supports something
(said support may end up being removed....).  I guess for a draft that's ok...

Why write "negation" instead of ":not()"?

The ::before/::after notes should mentions something about support (or lack
thereof) for the values allowed by CSS2.1 for display, overflow, float.

"descendant" is not spelled "descendent".  I'm not sure what the note here has
to do with how we implement it.  Same for the note on child combinators and
direct adjacent combinators.  Why are these last "combinators", btw, instead of
"combinator"?  That applies to all of them.

Why are notes in the Gecko support chart talking about what IE supports?

border-collapse has known dynamic issues, last I checked (eg insertion of cells,
etc).

As of 1.8, we will have support for "cursor: <uri>" at least on some platforms.

I'm not sure it's worth mentioning 1.8a4 in the comments for overflow.... 
mention "1.8" (once that's released).

We have limited support for page-break-before/after, iirc.

I didn't really review the version numbers.
Comment 8 Sam Collett 2005-02-14 10:52:57 PST
(In reply to comment #7)
> Why are notes in the Gecko support chart talking about what IE supports?

Perhaps IE should not be mentioned. While it may be useful, this is a Gecko
reference and including other browser information (except those based on Gecko)
would mean more work.

A section for Mozilla only CSS properties may be helpful as well (i.e. for
extension developers).
Comment 9 Anne (:annevk) 2005-02-14 12:55:52 PST
(In reply to comment #8)
> A section for Mozilla only CSS properties may be helpful as well (i.e. for
> extension developers).

As I mentioned in the documentation newsgroup that should only include
properties like -moz-margin-end and such. But I do not think I want them on this
page.
Comment 10 Anne (:annevk) 2005-02-14 13:01:33 PST
Created attachment 174315 [details]
draft #3

This addresses most of Boris' comments and adds some bug numbers as requested
by Robert Kaiser. I also added an acknowledgements section to credit people who
contributed to this.

There is a temporary |border="1"| added to make reviewing these drafts easier.
Comment 11 Jeff Walden [:Waldo] (remove +bmo to email) 2005-02-14 20:08:09 PST
Comment on attachment 174315 [details]
draft #3

Just some random things as I see them...

>  of <ABBR>CSS</ABBR> support. Implented features may have (filed or unfiled) bugs, and

s/Implented/Implemented/

>  build from Gecko 1.7.5. Mozilla Suite version numbers are equal to those of

s/build/built/

>  Gecko.) Versions prior to version 1.0 are listed as 1.0. The author of this
>  document does not consider Gecko versions released before 1.0 to be of any
>  importance on today�s web.

Instead of the last sentence, could you perhaps just say that versions prior to
1.0 are listed as 1.0 to save space?  The last sentence seems somewhat odd as
it sits, and if I were writing this I'd try to remove it.  Realistically, no
one cares about pre-1.0 CSS support, so I'm not sure it's worth explicitly
addressing in this manner.  (Actually, on second thought a better idea might be
to specify that the version number listed is the number of the first stable
milestone release to support that property.  That automatically excludes <1.0
if my knowledge of project history is correct.)

> </P><P>Since you should never rely on Mozilla extension properties they are not
>  listed. If you are using them at the moment you should not be surprised to
>  find out Mozilla does no longer support the property you are using.

How about:

"Mozilla CSS extensions (those prefixed with <code>-moz-</code>) are not listed
here.  They are intended for internal use within the browser only and must not
be relied upon to work in web pages, because <strong>they can and will
break</strong>."

> <P class="note">All non-normative (informative) properties are not listed. This basically means that
>  the entire <A title="Aural style sheets" href="http://www.w3.org/TR/CSS21/aural.html">appendix A</A>
>  is excluded from this list.

How about:

"Non-normative (informative) properties, including those specified for aural
style sheets in <A href="http://www.w3.org/TR/CSS21/aural.html">appendix A</A>
of the <abbr>CSS</abbr> 2.1 specification, are not listed."
Comment 12 Anne (:annevk) 2005-02-17 07:41:33 PST
Created attachment 174583 [details]
draft #4

This addresses most (if not all) of the comments so far.
Comment 13 Anne (:annevk) 2005-02-20 08:54:14 PST
Created attachment 174859 [details]
draft #5

Markup improvements and included suggestions from fantasai (IRC,
#documentation).
Comment 14 Boris Zbarsky [:bz] 2005-02-21 15:01:23 PST
It'll take me some time to get to this (busy with other things)
Comment 15 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2005-03-16 00:01:28 PST
Comment on attachment 174583 [details]
draft #4

putting a dummy review request to myself on an older version so I remember to
look at it too
Comment 16 Sekundes 2005-03-16 00:12:29 PST
Gecko does not support few values of CSS 2.1 display property either.
e.g. run-in, inline-block, and inline-table.
Comment 17 Anbo Motohiko 2005-03-31 03:18:43 PST
> cursor  	Yes 	1.0 	Mozilla does not support the <uri> value yet. (Bug 38447.)
Yes, 'cursor: url(uri)' is supported in 1.8 in some platforms, and 'cursor:
progress' is not supported in 1.6 and before (Bug 230343).

> font-weight  	Yes 	1.0
'bolder' and 'lighter' keywords are not supported. Bug 93725.

> page  	? 	- 	-
'@page' rule?

> page-break-after  	? 	- 	-
> page-break-before 	? 	- 	-
> page-break-inside 	? 	- 	-
'page-break-before: always' and 'page-break-after: always' are supported, left
things are not supported. Bug 132035.
And 'widows' and 'orphans' are not supported, I think.


IMHO, changing title to 'CSS support chart for Firefox 1.0.x and Mozilla
Application Suite 1.7.x' will make this chart better thing, because users will
want 'Is this property/value supported in my browser?', not development history
('Supported since').
And please add value 'Partly' to 'Supported' column. e.g. in the draft
'white-space' property says 'Yes', but in notes there are words 'not supported'
and 'buggy'.
Comment 18 Christian :Biesinger (don't email me, ping me on IRC) 2005-03-31 04:40:42 PST
(In reply to comment #17)
> IMHO, changing title to 'CSS support chart for Firefox 1.0.x and Mozilla
> Application Suite 1.7.x' will make this chart better thing, because users will
> want 'Is this property/value supported in my browser?', not development history
> ('Supported since').

I beg to differ. I expect web developers to care about the browser versions in
which their CSS works, so they can say "This webpage requires Mozilla 1.4 or
newer" or somesuch.
Comment 19 Anne (:annevk) 2005-03-31 04:52:10 PST
I will add 'outline', the notes on 'display', 'cursor:url()', the notes on
'font-weight', the notes on 'cursor:progress', 'page-break-*', Partly and remove
'page' which was from CSS2 in draft #6.

About the title and 'supported since', that is not going to change.
Comment 20 Boris Zbarsky [:bz] 2005-03-31 07:44:00 PST
> 'bolder' and 'lighter' keywords are not supported. Bug 93725.

This goes back to the definition of "supported" (see comment 4).  If a property
is buggy in edge cases (which is what we have here), is it "supported"?  What
makes something an "edge case"?
Comment 21 Anne (:annevk) 2005-03-31 08:43:00 PST
See the definition of supported in comment 6 which is more recent and more correct.
Comment 22 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2005-03-31 09:04:05 PST
bolder and lighter are supported, they're just not fully correct; then again, we
basically only support two font weights anyway, so really all of font-weight has
that caveat, not just bolder and lighter.
Comment 23 Anbo Motohiko 2005-09-27 05:54:26 PDT
(In reply to comment #13)
> Created an attachment (id=174859) [edit]
> draft #5
Needs update for Gecko/1.8.


These selectors are newly supported in Gecko/1.8:
:enabled and :disabled (bug 84400)
:valid, :invalid, :in-range and :out-of-range (bug 302462)
:required and :optional (Bug 302608)



'display' property:
Not only 'inline-block' (Bug 9458), but also 'run-in' (Bug 2056) and
'inline-table' (Bug 18217) are not supported.
Comment 24 Zibi Braniecki [:gandalf][:zibi] 2005-09-27 06:03:35 PDT
clip works since 1.0.
Comment 25 Reed Loden [:reed] (use needinfo?) 2006-01-25 23:32:20 PST
--> developer.mozilla.org
Comment 26 Deb Richardson [:dria] (plz NEEDINFO) 2006-01-26 05:38:33 PST
If it's all the same to everyone (and Anne agrees to it and to the licensing of this under the Creative Commons: Attribute-Sharealike license), I'll add this to the MDC documentation wiki.

Let me know if that's ok (or not ok), and I'll set aside a couple of hours to do this over the weekend.
Comment 27 Anne (:annevk) 2006-01-26 06:00:01 PST
It's ok. But note that I still haven't recieved any "full" reviews so far. But now that it will be on a wiki I guess that's not really an issue anymore.
Comment 28 Boris Zbarsky [:bz] 2006-01-26 07:13:42 PST
If we add this to the wiki, we should very clearly and in big letters say that it's not authoritative...  I, for one, have no idea whether this chart is correct or not (nor time to check).

But yeah, if we wiki it as a "work in progress", that would be a decent idea, I think.
Comment 29 Boris Zbarsky [:bz] 2006-01-26 07:14:38 PST
One other thing.  If we're putting this out in public, is someone volunteering to keep it updated as things change?  With 1.9a happening, this will be fairly often, I suspect.
Comment 30 Deb Richardson [:dria] (plz NEEDINFO) 2006-01-26 07:54:58 PST
Having it in the MDC wiki should at least simplify the process of keeping it updated.  Having someone volunteer to "own" it and ensure updates are made (and reviewed) would be beneficial.  I'm just not sure who that could/should be.
Comment 31 Deb Richardson [:dria] (plz NEEDINFO) 2006-02-08 21:02:39 PST
I've migrated this chart into the English MDC wiki here:
http://developer.mozilla.org/en/docs/Mozilla_CSS_support_chart

Review to ensure that I've migrated it all correctly would be appreciated.  It is open for editing/updating, so feel free to make corrections or additions directly.

If there's anything else I can do to help with this, let me know.
Comment 32 Simon Paquet [:sipaq] 2008-08-22 07:26:51 PDT
*** Bug 451708 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.